#ifndef _BBCBILLBOARDCLOUD_H
#define _BBCBILLBOARDCLOUD_H

#include <BBCBillboardGroup.h>
#include <BBCBillboard.h>
#include <BBCEntityCluster.h>
#include <BBCEntity.h>

namespace BBC {

class _BBCExport BillboardCloud {
  public:
    BillboardCloud();

    ~BillboardCloud();


  protected:
	  std::vector<Billboard*> mBillboardList;
	  
	  std::vector<BillboardGroup*> mBillboardGroupList;

  public:
	std::vector<Billboard*>* getBillboardList();

	void setBillboardList(std::vector<Billboard*> &value);

    void addBillboard(Billboard* value);

    void removeBillboard(unsigned int value);

	Billboard* getBillboard(unsigned int value);	

	unsigned int BillboardCloud::getNumBillboards();

	void generateBillboardCloud(bool mergeBillboards);

	void initializeBillboardCloudGroups(unsigned int numberGroups);

	void generateBillboardCloudGroups();

	unsigned int getNumBillboardGroups();

	BillboardGroup* getBillboardGroup(unsigned int iBillboardGroup);

	void addBillboardGroup(BillboardGroup *value); 

	void removeBillboardGroup(unsigned int value);

  protected:
	Entity *mEntity;


  public:
	Entity* getEntity();

	void setEntity(Entity *value);

};

}
#endif
